//     ।  S7_300, S7_400
//=======================================================================

typedef struct       //   ॣ S7_300, S7_400
{
    byte   nom_ab;       //   ( DB- )
    byte   type_FM;      // ⨯ : 0 = SM, 1 = FM

    word_s    MOD_MAN;      // ०
    byte   FLAGS_SM[2];  // ਧ  DB ⨯ SM
    byte   FLAGS_FM[2];  // ਧ  DB ⨯ FM
    word_s    PV_cod;       // ६
    word_s    SP_cod;       // 
    word_s    MV_cod;       // 室
    float  kfs[8];       // GAIN,TI,TD,TM_LAG,DEADB_W,LMN_LLM,LMN_HLM,DISV
} reg_S7;

typedef struct   // .   .  ࠬ஢ S7_300
{
    word_s  addr;   //  ࢮ . ࠬ.  reck'e
    word_s  len;    //  .   
} an_S300;

typedef struct          //  DB ॣ ᨣ쭮  SM
{
//--------------------------------------------------------------------------
  unsigned  COM_RST   : 1 ;  // 0; complete restart                     0.0
  unsigned  MAN_ON    : 1 ;  // 1; : 0 = , 1 =  (. 1.0)   0.1
  unsigned  PVPER_ON  : 1 ;  // 0; 0 = ᨣ  , 1 =          0.2
  unsigned  P_SEL     : 1 ;  // 1; 0 = ய.. , 1 =       0.3
  unsigned  I_SEL     : 1 ;  // 1; 0 = ⥣.. , 1 =        0.4
  unsigned  INT_HOLD  : 1 ;  // 0; integral action hold                 0.5
  unsigned  I_ITL_ON  : 1 ;  // 0; initialization integral action       0.6
  unsigned  D_SEL     : 1 ;  // 0; 0 = .. , 1 =        0.7

  unsigned  MOD_CAS   : 1 ;  // 0; : 0= 0.1, 1= ( )   1.0
  unsigned  resv_1_1  : 1 ;  //                                         1.1
  unsigned  resv_1_2  : 1 ;  //                                         1.2
  unsigned  resv_1_3  : 1 ;  //                                         1.3
  unsigned  resv_1_4  : 1 ;  //                                         1.4
  unsigned  resv_1_5  : 1 ;  //                                         1.5
  unsigned  resv_1_6  : 1 ;  //                                         1.6
  unsigned  resv_1_7  : 1 ;  //                                         1.7

  long   CYCLE;    // >=1ms;       1s;    ६ 横, ᥪ                2
  float  SP_INT;   // -100..100%;  0.0;   , %                      6
  float  PV_IN;    // -100..100%;  0.0;    樨 ६, %     10
  word_s    PV_PER;   //              0;     室 稪    27648    14
  float  MANUAL;   // -100..100%;  0.0;     , %                 16
  float  GAIN;     //              2.0;   樥 ᨫ            20
  long   TI;       // >=CYCLE;     20s;   ६ ⥣஢, ᥪ       24
  long   TD;       // >=CYCLE;     10s;   ६ ७஢, ᥪ    28
  long   TM_LAG;   // >=CYCLE/2;   2s;    ६ 䨫樨, ᥪ           32
  float  DEADB_W;  // >=0.0%;      0.0;    ⢨⥫쭮          36
  float  LMN_HLM;  // ..100%;      100.0;  ࠭ 室, %       40
  float  LMN_LLM;  // -100%..      0.0;    ࠭ 室, %        44
  float  PV_FAC;   //              1.0;   . ଠ樨 ६  48
  float  PV_OFF;   //              0.0;   ᬥ. ଠ. ६, %   52
  float  LMN_FAC;  //              1.0;   . ଠ樨 室      56
  float  LMN_OFF;  //              0.0;   ᬥ饭 ଠ. 室, %    60
  float  I_ITLVAL; // -100..100%;  0.0;   . 稭 ⥣. .    64
  float  DISV;     // -100..100%;  0.0;   ன,襭,ࠧ  68
  float  LMN;      //              0.0;   室, %                        72
  word_s    LMN_PER;  //              0;     室    27648           76
  word   resv2;    //                                                     78
  float  LMN_P;    //              0.0;   ய. ⠢., %         80
  float  LMN_I;    //              0.0;   ⥣ࠫ쭠 ⠢, %    84
  float  LMN_D;    //              0.0;   . ⠢., %          88
  float  PV;       //              0.0;   ६, %                   92
//---------------------------------------------------------------------------
} DB_SM_S7;

typedef struct          //  DB ॣ 㭪樮쭮  FM
{
//---------------------------------------------------------------------------
  float  DEADB_W;  // >=0.0%;      0.0;    ⢨⥫쭮          28
  float  GAIN;     //              1.0;   樥 ᨫ            32
  float  TI;       // >=samp.t; 3000.0;   ६ ⥣஢, ᥪ       36
  float  TD;       // >=0.0;       0.0;   ६ ७஢, ᥪ    40
  float  TM_LAG;   // >=samp.t/2;  5.0;   ६ 䨫樨, ᥪ           44
  float  LMN_SAFE; // -100..100%;  0.0;   ࠭ 室               48
  float  LMN_HLM;  // ..100%;    100.0;    ࠭ 室, %       52
  float  LMN_LLM;  // -100%..;     0.0;    ࠭ 室, %        56
  float  MTR_TM;   // >=samp.t;   60.0;   motor manipulated value, sec    60
  float  PULSE_TM; // >=0.0;       0.2;   minimum pulse time, sec         64
  float  BREAK_TM; // >=0.0;       0.2;   minimum break time, sec         68
  float  SP_RE;    // ;     0.0;   譥                  72
  float  LMN_RE;   // ;       0.0;   譨 室, %                76
  float  LMNRSVAL; // -100..100%,  0.0;   .. 室  樨   80

  unsigned  SAFE_ON    : 1 ; // safety position on                      84.0
  unsigned  LMNTRKON   : 1 ; // match (LMN from analog inpyt)           84.1
  unsigned  LMN_REON   : 1 ; // ; ext. manip. value on             84.2
  unsigned  LMNRHSRE   : 1 ; // high lim signal of rep MV               84.3
  unsigned  LMNRLSRE   : 1 ; // low  -"-                                84.4
  unsigned  LMNSOPON   : 1 ; // manipulated signal operat. on           84.5
  unsigned  LMNUP_OP   : 1 ; // manipulated signal up operat.           84.6
  unsigned  LMNDN_OP   : 1 ; // manipulat. signal down operat           84.7

  unsigned  MONERSEL   : 1 ; //                                         85.0
  unsigned  LMNRS_ON   : 1 ; //                                         85.1
  unsigned  FUZID_ON   : 1 ; //                                         85.2
  unsigned  SPINT_EN   : 1 ; // 0: =SP_INT, 1: =SP_RE     85.3
  unsigned  P_SEL      : 1 ; //                                         85.4
  unsigned  PFDB_SEL   : 1 ; //                                         85.5
  unsigned  resv_85_6  : 1 ; //                                         85.6
  unsigned  resv_85_7  : 1 ; //                                         85.7

  word_s    D_EL_SEL; // D-element input for controller                      86
  word_s    MOD_ADDR; // FM355/455 module address                            88
  word_s    CHANNEL;  //                                          90
  word   resv_92;  // ਧ ?                                          92
  float  SP;       //                                              94
  float  PV;       // ६                                          98
  float  ER;       // ᮣᮢ                                     102
  float  DISV;     // ன,襭,ࠧ                      106
  float  LMN;      // 室, %                                            110
  float  LMN_A;    // man.var.A of split range funct                      114
  float  LMN_B;    // man.var.B of split range funct                      118
  word   resv_122; // ਧ ?                                          122
  word   resv_124; // ਧ ?                                          124
  word_s    RET_VALU; //  * Return value SFC 58/59                           126
  float  SP_INT;   // ७                                   128
  float  SP_OP;    // setpoint operation                                  132
  float  LMN_OP;   // 室 operation                                     136
  word   resv_140; // ਧ ?                                          140
//---------------------------------------------------------------------------
} DB_FM_S7;

